# Index

Symbols | A | B | C | D | E | F | G | H | I | L | M | N | O | P | Q | R | S | T | U | V

## Symbols

- ::/1
  - Control construct
- ::/2
  - Control construct
- <</2
  - Control construct
- []/1
  - Control construct

- \+/1
  - Built-in method
- ^^/1
  - Control construct
- {}/1
  - Control construct

## A

- abolish/1
  - Built-in method
- abolish_category/1
  - Built-in predicate
- abolish_events/5
  - Built-in predicate
- abolish_object/1
  - Built-in predicate
- abolish_protocol/1
  - Built-in predicate
- abstract class
- abstract method
- adapter file

- after/3
  - Built-in method
- alias/2
  - Directive
- always_true_or_false_goals
  - Flag
- ancestor
- ask_question/5
  - Built-in method
- asserta/1
  - Built-in method
- assertz/1
  - Built-in method

## B

- backend Prolog compiler
- bagof/3
  - Built-in method
- before/3
  - Built-in method
- begin_of_file
- behavioral reflection
- black-box view
- Built-in method
  - \+/1
  - abolish/1
  - after/3
  - ask_question/5
  - asserta/1
  - assertz/1
  - bagof/3
  - before/3
  - call//1-N
  - call/1-N
  - catch/3
  - clause/2
  - coinductive_success_hook/1-2
  - context/1
  - current_op/3
  - current_predicate/1
  - domain_error/2
  - eos//0
  - evaluation_error/1
  - existence_error/2
  - expand_goal/2
  - expand_term/2
  - findall/3
  - findall/4
  - forall/2
  - forward/1
  - goal_expansion/2
  - ignore/1
  - instantiation_error/0
  - message_hook/4
  - message_prefix_stream/4
  - message_tokens//2
  - once/1
  - parameter/2
  - permission_error/3
  - phrase//1
  - phrase/2
  - phrase/3
  - predicate_property/2
  - print_message/3
  - print_message_token/4
  - print_message_tokens/3
  - question_hook/6
  - question_prompt_stream/4
  - representation_error/1
  - resource_error/1
  - retract/1
  - retractall/1
  - self/1
  - sender/1
  - setof/3
  - syntax_error/1
  - system_error/0
  - term_expansion/2
  - this/1
  - throw/1
  - type_error/2

- built-in method
- Built-in predicate
  - abolish_category/1
  - abolish_events/5
  - abolish_object/1
  - abolish_protocol/1
  - category_property/2
  - complements_object/2
  - conforms_to_protocol/2-3
  - create_category/4
  - create_logtalk_flag/3
  - create_object/4
  - create_protocol/3
  - current_category/1
  - current_event/5
  - current_logtalk_flag/2
  - current_object/1
  - current_protocol/1
  - define_events/5
  - extends_category/2-3
  - extends_object/2-3
  - extends_protocol/2-3
  - implements_protocol/2-3
  - imports_category/2-3
  - instantiates_class/2-3
  - logtalk_compile/1
  - logtalk_compile/2
  - logtalk_library_path/2
  - logtalk_linter_hook/7
  - logtalk_load/1
  - logtalk_load/2
  - logtalk_load_context/2
  - logtalk_make/0
  - logtalk_make/1
  - logtalk_make_target_action/1
  - object_property/2
  - protocol_property/2
  - set_logtalk_flag/2
  - specializes_class/2-3
  - threaded/1
  - threaded_call/1-2
  - threaded_cancel/1
  - threaded_engine/1
  - threaded_engine_create/3
  - threaded_engine_destroy/1
  - threaded_engine_fetch/1
  - threaded_engine_next/2
  - threaded_engine_next_reified/2
  - threaded_engine_post/2
  - threaded_engine_self/1
  - threaded_engine_yield/1
  - threaded_exit/1-2
  - threaded_ignore/1
  - threaded_notify/1
  - threaded_once/1-2
  - threaded_peek/1-2
  - threaded_wait/1
- built-in predicate
- built_in/0
  - Directive

## C

- call//1-N
  - Built-in method
- call/1-N
  - Built-in method
- catch/3
  - Built-in method
- category
- category/1-4
  - Directive
- category_property/2
  - Built-in predicate
- class
- clause/2
  - Built-in method
- clean
  - Flag
- closed-world assumption
- closure
- code_prefix
  - Flag
- coinduction
  - Flag
- coinductive predicate
- coinductive/1
  - Directive
- coinductive_success_hook/1-2
  - Built-in method
- complementing category
- complements
  - Flag
- complements_object/2
  - Built-in predicate
- component
- conforms_to_protocol/2-3
  - Built-in predicate

- context/1
  - Built-in method
- context_switching_calls
  - Flag
- Control construct
  - ::/1
  - ::/2
  - <</2
  - []/1
  - ^^/1
  - {}/1
- create_category/4
  - Built-in predicate
- create_logtalk_flag/3
  - Built-in predicate
- create_object/4
  - Built-in predicate
- create_protocol/3
  - Built-in predicate
- current_category/1
  - Built-in predicate
- current_event/5
  - Built-in predicate
- current_logtalk_flag/2
  - Built-in predicate
- current_object/1
  - Built-in predicate
- current_op/3
  - Built-in method
- current_predicate/1
  - Built-in method
- current_protocol/1
  - Built-in predicate

## D

- debug
  - Flag
- define_events/5
  - Built-in predicate
- deprecated
  - Flag
- Directive
  - alias/2
  - built_in/0
  - category/1-4
  - coinductive/1
  - discontiguous/1
  - dynamic/0
  - dynamic/1
  - elif/1
  - else/0
  - encoding/1
  - end_category/0
  - end_object/0
  - end_protocol/0
  - endif/0
  - if/1
  - include/1
  - info/1
  - info/2
  - initialization/1
  - meta_non_terminal/1
  - meta_predicate/1
  - mode/2
  - multifile/1
  - object/1-5
  - op/3
  - private/1
  - protected/1
  - protocol/1-2
  - public/1
  - set_logtalk_flag/2
  - synchronized/1
  - threaded/0
  - use_module/2
  - uses/1
  - uses/2

- directive
- discontiguous/1
  - Directive
- doclet file
- doclet object
- domain_error/2
  - Built-in method
- duplicated_clauses
  - Flag
- duplicated_directives
  - Flag
- dynamic binding
- dynamic entity
- dynamic/0
  - Directive
- dynamic/1
  - Directive
- dynamic_declarations
  - Flag

## E

- early binding
- elif/1
  - Directive
- else/0
  - Directive
- encapsulation
- encoding/1
  - Directive
- encoding_directive
  - Flag
- end_category/0
  - Directive
- end_object/0
  - Directive
- end_of_file
- end_protocol/0
  - Directive
- endif/0
  - Directive
- engines
  - Flag

- entity
- entity directive
- eos//0
  - Built-in method
- evaluation_error/1
  - Built-in method
- event
- events
  - Flag
- existence_error/2
  - Built-in method
- expand_goal/2
  - Built-in method
- expand_term/2
  - Built-in method
- expansion workflow
- extends_category/2-3
  - Built-in predicate
- extends_object/2-3
  - Built-in predicate
- extends_protocol/2-3
  - Built-in predicate

## F

- findall/3
  - Built-in method
- findall/4
  - Built-in method
- Flag
  - always_true_or_false_goals
  - clean
  - code_prefix
  - coinduction
  - complements
  - context_switching_calls
  - debug
  - deprecated
  - duplicated_clauses
  - duplicated_directives
  - dynamic_declarations
  - encoding_directive
  - engines
  - events
  - hook
  - lambda_variables
  - missing_directives
  - modules
  - naming
  - optimize
  - portability
  - prolog_compatible_version
  - prolog_compiler
  - prolog_conformance
  - prolog_dialect
  - prolog_loader
  - prolog_version
  - redefined_built_ins
  - redefined_operators
  - relative_to
  - reload
  - report
  - scratch_directory
  - settings_file
  - singleton_variables
  - source_data
  - steadfastness
  - suspicious_calls
  - tabling
  - tail_recursive
  - threads
  - trivial_goal_fails
  - undefined_predicates
  - underscore_variables
  - unicode
  - unknown_entities
  - unknown_predicates
  - version_data

- forall/2
  - Built-in method
- forward/1
  - Built-in method

## G

- goal_expansion/2
  - Built-in method

- grammar rule
- grammar rule non-terminal
- grammar rule terminal

## H

- hook
  - Flag

- hook object
- hook predicate
- hot patching

## I

- identity
- if/1
  - Directive
- ignore/1
  - Built-in method
- implements_protocol/2-3
  - Built-in predicate
- imports_category/2-3
  - Built-in predicate
- include/1
  - Directive
- info/1
  - Directive

- info/2
  - Directive
- inheritance
- initialization/1
  - Directive
- instance
- instantiates_class/2-3
  - Built-in predicate
- instantiation
- instantiation_error/0
  - Built-in method
- interface

## L

- lambda expression
- lambda free variable
- lambda parameter
- lambda_variables
  - Flag
- late binding
- library
- library alias
- library notation
- loader file
- local predicate
- logtalk_compile/1
  - Built-in predicate
- logtalk_compile/2
  - Built-in predicate

- logtalk_library_path/2
  - Built-in predicate
- logtalk_linter_hook/7
  - Built-in predicate
- logtalk_load/1
  - Built-in predicate
- logtalk_load/2
  - Built-in predicate
- logtalk_load_context/2
  - Built-in predicate
- logtalk_make/0
  - Built-in predicate
- logtalk_make/1
  - Built-in predicate
- logtalk_make_target_action/1
  - Built-in predicate

## M

- message
- message lookup
- message to self
- message_hook/4
  - Built-in method
- message_prefix_stream/4
  - Built-in method
- message_tokens//2
  - Built-in method
- meta-argument
- meta-interpreter
- meta-predicate
- meta_non_terminal/1
  - Directive

- meta_predicate/1
  - Directive
- metaclass
- method
- missing_directives
  - Flag
- mode/2
  - Directive
- module
- modules
  - Flag
- monitor
- multifile predicate
- multifile/1
  - Directive

## N

- naming
  - Flag

## O

- object
- object database
- object/1-5
  - Directive
- object_property/2
  - Built-in predicate

- once/1
  - Built-in method
- op/3
  - Directive
- optimize
  - Flag

## P

- parameter
- parameter variable
- parameter/2
  - Built-in method
- parametric category
- parametric entity
- parametric object
- parametric object proxy
- parent
- permission_error/3
  - Built-in method
- phrase//1
  - Built-in method
- phrase/2
  - Built-in method
- phrase/3
  - Built-in method
- polymorphism
- portability
  - Flag
- predicate
- predicate alias
- predicate declaration
- predicate definition
- predicate directive
- predicate scope container
- predicate scope directive
- predicate shorthand
- predicate_property/2
  - Built-in method
- primary predicate declaration
- print_message/3
  - Built-in method
- print_message_token/4
  - Built-in method

- print_message_tokens/3
  - Built-in method
- private inheritance
- private predicate
- private/1
  - Directive
- profiler
- prolog_compatible_version
  - Flag
- prolog_compiler
  - Flag
- prolog_conformance
  - Flag
- prolog_dialect
  - Flag
- prolog_loader
  - Flag
- prolog_version
  - Flag
- protected inheritance
- protected predicate
- protected/1
  - Directive
- protocol
- protocol/1-2
  - Directive
- protocol_property/2
  - Built-in predicate
- prototype
- public inheritance
- public predicate
- public/1
  - Directive

## Q

- question_hook/6
  - Built-in method

- question_prompt_stream/4
  - Built-in method

## R

- redefined_built_ins
  - Flag
- redefined_operators
  - Flag
- reflection
- relative_to
  - Flag
- reload
  - Flag

- report
  - Flag
- representation_error/1
  - Built-in method
- resource_error/1
  - Built-in method
- retract/1
  - Built-in method
- retractall/1
  - Built-in method

## S

- scratch directory
- scratch_directory
  - Flag
- self
- self/1
  - Built-in method
- sender
- sender/1
  - Built-in method
- set_logtalk_flag/2
  - Built-in predicate
  - Directive
- setof/3
  - Built-in method
- settings file
- settings_file
  - Flag
- singleton method
- singleton_variables
  - Flag
- source file
- source file directive

- source_data
  - Flag
- specialization
- specializes_class/2-3
  - Built-in predicate
- static binding
- static entity
- steadfastness
  - Flag
- structural reflection
- subclass
- super call
- superclass
- suspicious_calls
  - Flag
- synchronized predicate
- synchronized/1
  - Directive
- syntax_error/1
  - Built-in method
- system_error/0
  - Built-in method

## T

- tabling
  - Flag
- tail_recursive
  - Flag
- template method
- term_expansion/2
  - Built-in method
- tester file
- this
- this/1
  - Built-in method
- threaded engine
- threaded/0
  - Directive
- threaded/1
  - Built-in predicate
- threaded_call/1-2
  - Built-in predicate
- threaded_cancel/1
  - Built-in predicate
- threaded_engine/1
  - Built-in predicate
- threaded_engine_create/3
  - Built-in predicate
- threaded_engine_destroy/1
  - Built-in predicate
- threaded_engine_fetch/1
  - Built-in predicate
- threaded_engine_next/2
  - Built-in predicate

- threaded_engine_next_reified/2
  - Built-in predicate
- threaded_engine_post/2
  - Built-in predicate
- threaded_engine_self/1
  - Built-in predicate
- threaded_engine_yield/1
  - Built-in predicate
- threaded_exit/1-2
  - Built-in predicate
- threaded_ignore/1
  - Built-in predicate
- threaded_notify/1
  - Built-in predicate
- threaded_once/1-2
  - Built-in predicate
- threaded_peek/1-2
  - Built-in predicate
- threaded_wait/1
  - Built-in predicate
- threads
  - Flag
- throw/1
  - Built-in method
- transparent-box view
- trivial_goal_fails
  - Flag
- type_error/2
  - Built-in method

## U

- undefined_predicates
  - Flag
- underscore_variables
  - Flag
- unicode
  - Flag
- unknown_entities
  - Flag

- unknown_predicates
  - Flag
- use_module/2
  - Directive
- uses/1
  - Directive
- uses/2
  - Directive

## V

- version_data
  - Flag

- visible predicate